<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UsageSearch StructType
 * @subpackage Structs
 */
class UsageSearch extends SearchRecord
{
    /**
     * The basic
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\UsageSearchBasic
     */
    public $basic;
    /**
     * The chargeJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\ChargeSearchBasic
     */
    public $chargeJoin;
    /**
     * The customerJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\CustomerSearchBasic
     */
    public $customerJoin;
    /**
     * The itemJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\ItemSearchBasic
     */
    public $itemJoin;
    /**
     * The subscriptionPlanJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\ItemSearchBasic
     */
    public $subscriptionPlanJoin;
    /**
     * Constructor method for UsageSearch
     * @uses UsageSearch::setBasic()
     * @uses UsageSearch::setChargeJoin()
     * @uses UsageSearch::setCustomerJoin()
     * @uses UsageSearch::setItemJoin()
     * @uses UsageSearch::setSubscriptionPlanJoin()
     * @param \StructType\UsageSearchBasic $basic
     * @param \StructType\ChargeSearchBasic $chargeJoin
     * @param \StructType\CustomerSearchBasic $customerJoin
     * @param \StructType\ItemSearchBasic $itemJoin
     * @param \StructType\ItemSearchBasic $subscriptionPlanJoin
     */
    public function __construct(\StructType\UsageSearchBasic $basic = null, \StructType\ChargeSearchBasic $chargeJoin = null, \StructType\CustomerSearchBasic $customerJoin = null, \StructType\ItemSearchBasic $itemJoin = null, \StructType\ItemSearchBasic $subscriptionPlanJoin = null)
    {
        $this
            ->setBasic($basic)
            ->setChargeJoin($chargeJoin)
            ->setCustomerJoin($customerJoin)
            ->setItemJoin($itemJoin)
            ->setSubscriptionPlanJoin($subscriptionPlanJoin);
    }
    /**
     * Get basic value
     * @return \StructType\UsageSearchBasic|null
     */
    public function getBasic()
    {
        return $this->basic;
    }
    /**
     * Set basic value
     * @param \StructType\UsageSearchBasic $basic
     * @return \StructType\UsageSearch
     */
    public function setBasic(\StructType\UsageSearchBasic $basic = null)
    {
        $this->basic = $basic;
        return $this;
    }
    /**
     * Get chargeJoin value
     * @return \StructType\ChargeSearchBasic|null
     */
    public function getChargeJoin()
    {
        return $this->chargeJoin;
    }
    /**
     * Set chargeJoin value
     * @param \StructType\ChargeSearchBasic $chargeJoin
     * @return \StructType\UsageSearch
     */
    public function setChargeJoin(\StructType\ChargeSearchBasic $chargeJoin = null)
    {
        $this->chargeJoin = $chargeJoin;
        return $this;
    }
    /**
     * Get customerJoin value
     * @return \StructType\CustomerSearchBasic|null
     */
    public function getCustomerJoin()
    {
        return $this->customerJoin;
    }
    /**
     * Set customerJoin value
     * @param \StructType\CustomerSearchBasic $customerJoin
     * @return \StructType\UsageSearch
     */
    public function setCustomerJoin(\StructType\CustomerSearchBasic $customerJoin = null)
    {
        $this->customerJoin = $customerJoin;
        return $this;
    }
    /**
     * Get itemJoin value
     * @return \StructType\ItemSearchBasic|null
     */
    public function getItemJoin()
    {
        return $this->itemJoin;
    }
    /**
     * Set itemJoin value
     * @param \StructType\ItemSearchBasic $itemJoin
     * @return \StructType\UsageSearch
     */
    public function setItemJoin(\StructType\ItemSearchBasic $itemJoin = null)
    {
        $this->itemJoin = $itemJoin;
        return $this;
    }
    /**
     * Get subscriptionPlanJoin value
     * @return \StructType\ItemSearchBasic|null
     */
    public function getSubscriptionPlanJoin()
    {
        return $this->subscriptionPlanJoin;
    }
    /**
     * Set subscriptionPlanJoin value
     * @param \StructType\ItemSearchBasic $subscriptionPlanJoin
     * @return \StructType\UsageSearch
     */
    public function setSubscriptionPlanJoin(\StructType\ItemSearchBasic $subscriptionPlanJoin = null)
    {
        $this->subscriptionPlanJoin = $subscriptionPlanJoin;
        return $this;
    }
}
